
package de.ivu.elect.presentation.ergebnis.menu;

import javax.inject.Inject;

import de.ivu.elect.business.ergebnis.boundary.ErgebnisExtendedDAO;
import de.ivu.elect.business.ergebnis.entity.Ergebnisart;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.wahl.boundary.WahlSessionSelect;
import de.ivu.elect.business.wahl.entity.Wahl;
import de.ivu.elect.presentation.ergebnis.VorperiodeDatumFestlegenView;
import de.ivu.elect.presentation.menu.AbstractMenuItemEntry;
import de.ivu.elect.presentation.security.AbstractGebietSecurity;

public class VorperiodeDatumFestlegenMenuItemEntry extends AbstractMenuItemEntry {

  private static final long serialVersionUID = 1L;

  @Inject
  private transient ErgebnisExtendedDAO ergebnisExtendedDAO;

  @Inject
  private transient WahlSessionSelect wahlSessionSelect;

  public VorperiodeDatumFestlegenMenuItemEntry() {
    super();
  }

  @Override
  protected AbstractGebietSecurity getGebietSecurity() {
    return KEINE_GEBIET_SECURITY;
  }

  @Override
  public boolean isRendered() {
    return hasUseCasePermission(UseCasePermission.ERGEBNIS_EDIT) && wahlSessionSelect.isSelected()
        && isErgebnisVorperiodeVorhanden(wahlSessionSelect.getEntity());
  }

  private boolean isErgebnisVorperiodeVorhanden(Wahl wahl) {
    return !ergebnisExtendedDAO.findByWahlAndErgebnisart(wahl, Ergebnisart.VORPERIODE).isEmpty();
  }

  @Override
  public boolean isDisabledInternal() {
    return false;
  }

  @Override
  public String getTargetViewId() {
    return VorperiodeDatumFestlegenView.VIEW_ID;
  }

  @Override
  public String getLabelKey() {
    return "vorperiode.datum.festlegen.main.menu.item.label";
  }

  @Override
  public String getIcon() {
    return getIcons().getIconEdit();
  }
}
